import 'package:analyzer/dart/element/element.dart';
import 'package:like_sealed_gen/src/util.dart';

class SealedSwitchImplContent {
  final String className;
  final List<ClassElement> types;

  SealedSwitchImplContent(this.className, this.types);

  String content() {
    String typeChecker = "";
    String field = "";
    String constructorParameter = "";
    String caseFunction = "";
    for (var type in types) {
      final typeName = type.name;

      if (typeName == className) {
        typeChecker +=
            "(type is $typeName&& $typeName != null)? onDefault(type) : null";
        caseFunction +=
            "T onDefault($typeName value)=>${typeName.firstToLower}(value);";
        field += "final T Function($typeName)  ${typeName.firstToLower};";
        constructorParameter += "this.${typeName.firstToLower},";
      } else {
        typeChecker +=
            "(type is $typeName && $typeName != null) ? on$typeName(type) : ";
        caseFunction +=
            "T on$typeName($typeName value)=>${typeName.firstToLower}(value);";
        field += "final T Function($typeName)  ${typeName.firstToLower};";
        constructorParameter += "this.${typeName.firstToLower},";
      }
    }

    return """
    class ${className}SwitchImpl<T> implements ${className}Switch<T> {
      ${field}
      ${className}SwitchImpl(${constructorParameter.isEmpty ? "" : "{${constructorParameter}"}});
      
      T switchCase($className type)=>$typeChecker;
      
      $caseFunction
    }
    """;
  }
}
